#!/bin/sh
# Needed when not run in standard shell environment
#export CPCT_PATH=~/Quellcode/dev-cpctelera/cpctelera
rasm="/path-to/rasm"
at2disark="/path-to/Disark"
name=$(basename $(pwd))

# Prepare Arkos Tracker 2 song & sfx.
${rasm} assets/sound/CompileAT2Files.asm assets/sound/UniversalAt2Files -s -sl -sq
"${at2disark}" assets/sound/UniversalAt2Files.bin src/sound/At2Files.s --symbolFile assets/sound/UniversalAt2Files.sym --sourceProfile sdcc
# Add assembly code to player functions called externally to be conformant with __z88dk_callee
sed -i -e 's/_PLY_AKM_INIT::/_PLY_AKM_INIT::\npop af\npop hl\npop bc\npush af\nld a, c/g' -e 's/_PLY_AKM_PLAYSOUNDEFFECT::/_PLY_AKM_PLAYSOUNDEFFECT::\npop af\npop hl\npop bc\npush af\nld a,l\n/g' src/sound/At2Files.s

if [ "$1" = "clean" ]; then
  make clean
fi
if make; then
   if [ "$1" = "cass" ]; then
      mame cpc464 -cass ${name}.cdt -skip_gameinfo -noconfirm_quit -autoboot_delay 1 -autoboot_command "run\"\n"
   else 
      # Run disk image with mame or any other emulator.
      mame cpc6128 -flop1 ${name}.dsk -skip_gameinfo -noconfirm_quit -autoboot_delay 1 -autoboot_command "run\"${name}\n"
   fi
fi

