#ifndef ANIMATIONS_H
#define ANIMATIONS_H

#include "globals.h"
#include "entities.h"

/////////////////////////////////////////////////////////////////////////////
// Animation definitions.
typedef struct {
   u8 numFrames, delay;
   TFrame* firstFrame;
} TAnimData;
#define ANIM_NULL {0, 0, 0}   // Null animation data.

// Hero animations.
extern const TFrame const cFramesHeroIdle      [];
extern const TFrame const cFramesHeroWalking   [];
extern const TFrame const cFramesHeroJumping   [];
extern const TFrame const cFramesHeroFalling   [];
extern const TFrame const cFramesHeroUnsheating[];
extern const TFrame const cFramesHeroStepping  [];
extern const TFrame const cFramesHeroAttacking [];
extern const TFrame const cFramesHeroHolding   [];
extern const TFrame const cFramesHeroDefending [];
extern const TFrame const cFramesHeroSheating  [];
extern const TFrame const cFramesHeroHit       [];
extern const TFrame const cFramesHeroDying     [];

// Enemy animations.
extern const TFrame const cFramesEnemyIdle      [];
extern const TFrame const cFramesEnemyWalking   [];
extern const TFrame const cFramesEnemyJumping   [];
extern const TFrame const cFramesEnemyFalling   [];
extern const TFrame const cFramesEnemyUnsheating[];
extern const TFrame const cFramesEnemyStepping  [];
extern const TFrame const cFramesEnemyAttacking [];
extern const TFrame const cFramesEnemyHolding   [];
extern const TFrame const cFramesEnemyDefending [];
extern const TFrame const cFramesEnemySheating  [];
extern const TFrame const cFramesEnemyHit       [];
extern const TFrame const cFramesEnemyDying     [];

// Table with animation data: number of frames, frame delay and frame array pointer for each character state.
extern const TAnimData const cCharacterAnimations[2][NUM_CHAR_STATES];


void initCharacterAnimation(TCharacter *c);
void updateCharAnimation(TCharacter *c);

#endif /* ANIMATIONS_H */

