#ifndef CHARACTER_H
#define CHARACTER_H

#include "globals.h"
#include "keyboard.h"
#include "screens.h"
#include "animations.h"
#include "sound/sound.h"
#include "utils/utils.h"

extern TCharacter *currChar;     // The character that's being updated right now. Set with setCharacter().

inline void setCharacter(TCharacter *c);
void updateCharacter();
void chrWalk();
void chrJump();
void chrFall();
void chrAttack();
void chrStep();
void chrHit();
void chrDie();
void chrSlowDown();
void leaveFight(TCharacter *chr);
void setCharacterPosition(TCharacter *chr, u8 x, u8 y);
u8   faceOpponent(TCharacter *opponent);

#endif /* CHARACTER_H */

