#include "game.h"

u8 currentLevel;
u16 globalScore, levelScore;
EGameState gameState;
ERedrawFlag redrawHudFlags;


void getInput() {
   // Hero input.
   if (cpct_isKeyPressed(definedKeys[0])) {
      hero.nextActions |= ACT_LEFT;
   }
   else if (cpct_isKeyPressed(definedKeys[1])) {
      hero.nextActions |= ACT_RIGHT;
   }
   if (cpct_isKeyPressed(definedKeys[2])) {
      hero.nextActions |= ACT_UP;
   }
   else if (cpct_isKeyPressed(definedKeys[3])) {
      hero.nextActions |= ACT_DOWN;
   }
}


void initialize() {
   initEntities();
   initHud();
   initLevel();
   renderScreenComplete();
   gameState = GAME_RUNNING;
}


void showGame() {
   initialize();
   // Game loop.
   while (gameState == GAME_RUNNING) {
      getInput();
      updateEntities();
      renderScreen();
      // Pause game?
      if (cpct_isKeyPressed(Key_P)) {
         waitForKeyRelease(Key_P);
         while (1) {
            if (cpct_isKeyPressed(Key_Esc)) {
               gameState = GAME_BACK_TO_MENU;
               break;
            }
            else if (cpct_isKeyPressed(Key_P)) {
               waitForKeyRelease(Key_P);
               break;
            }
         }
      }
   }
}


void setGameOver(EGameState state) {
   gameState = state;
}


void changeScore(u16 amount) {
   levelScore += amount;
   redrawHudFlags |= REDRAW_HUD_SCORE;
}