#include "level_definitions.h"

/// Level 1 //////////////////////////////////////////////////////////////////////
const u8* const crunchedScreensLevel1[MAX_SCREENS] = {
   0,        0,       0,
   0,        0,       0,
   l01_2_0,  l01_2_1, l01_2_2,
};
const u16 const crunchedScreenSizesLevel1[MAX_SCREENS] = {
   0,              0,              0,
   0,              0,              0,
   l01_2_0_size_z, l01_2_1_size_z, l01_2_2_size_z,
};
//////////////////////////////////////////////////////////////////////////////////
/// Level 2 //////////////////////////////////////////////////////////////////////
const u8* const crunchedScreensLevel2[MAX_SCREENS] = {
   0,       l02_0_1, 0,
   l02_1_0, l02_1_1, l02_1_2,
   0,       0,       l02_2_2,
};
const u16 const crunchedScreenSizesLevel2[MAX_SCREENS] = {
   0,              l02_0_1_size_z, 0,
   l02_1_0_size_z, l02_1_1_size_z, l02_1_2_size_z,
   0,              0,              l02_2_2_size_z,
};
//////////////////////////////////////////////////////////////////////////////////
/// Level 3 //////////////////////////////////////////////////////////////////////
const u8* const crunchedScreensLevel3[MAX_SCREENS] = {
   0,      0,       0,
   0,      l03_1_1, l03_1_2,
   0,      l03_2_1, l03_2_2,
};
const u16 const crunchedScreenSizesLevel3[MAX_SCREENS] = {
   0,              0,              0,
   0,              l03_1_1_size_z, l03_1_2_size_z,
   0,              l03_2_1_size_z, l03_2_2_size_z,
};
//////////////////////////////////////////////////////////////////////////////////
/// Level 4 //////////////////////////////////////////////////////////////////////
const u8* const crunchedScreensLevel4[MAX_SCREENS] = {
   0,       0,       l04_0_2,
   l04_1_0, l04_1_1, l04_1_2,
   0,       l04_2_1, 0,
};
const u16 const crunchedScreenSizesLevel4[MAX_SCREENS] = {
   0,              0,              l04_0_2_size_z,
   l04_1_0_size_z, l04_1_1_size_z, l04_1_2_size_z,
   0,              l04_2_1_size_z, 0,
};
//////////////////////////////////////////////////////////////////////////////////
/// Level 5 //////////////////////////////////////////////////////////////////////
const u8* const crunchedScreensLevel5[MAX_SCREENS] = {
   0,       0,       l05_0_2,
   l05_1_0, l05_1_1, l05_1_2,
   l05_2_0, l05_2_1, l05_2_2,
};
const u16 const crunchedScreenSizesLevel5[MAX_SCREENS] = {
   0,              0,              l05_0_2_size_z,
   l05_1_0_size_z, l05_1_1_size_z, l05_1_2_size_z,
   l05_2_0_size_z, l05_2_1_size_z, l05_2_2_size_z,
};
//////////////////////////////////////////////////////////////////////////////////
/// Level 6 //////////////////////////////////////////////////////////////////////
const u8* const crunchedScreensLevel6[MAX_SCREENS] = {
   0,       0,       0,
   l06_1_0, l06_1_1, l06_1_2,
   l06_2_0, 0,       0,
};
const u16 const crunchedScreenSizesLevel6[MAX_SCREENS] = {
   0,              0,              0,
   l06_1_0_size_z, l06_1_1_size_z, l06_1_2_size_z,
   l06_2_0_size_z, 0,              0,
};
//////////////////////////////////////////////////////////////////////////////////

// An array of pointers to arrays with pointers to crunched screen arrays.
const u8** const allCrunchedScreens[NUM_LEVELS] = {
   crunchedScreensLevel1, crunchedScreensLevel2, crunchedScreensLevel3,
   crunchedScreensLevel4, crunchedScreensLevel5, crunchedScreensLevel6,
};

// Array of pointers to arrays with sizes of crunched screens.
const u16* const allCrunchedScreenSizes[NUM_LEVELS] = {
   crunchedScreenSizesLevel1, crunchedScreenSizesLevel2, crunchedScreenSizesLevel3,
   crunchedScreenSizesLevel4, crunchedScreenSizesLevel5, crunchedScreenSizesLevel6,
};