#include "sound.h"

volatile void* selMusic;
volatile void* currentMusic;
volatile u8 currentFx;
volatile u8 currentSubsong;

extern void* MAIN_START;
extern void* SFX_SOUNDEFFECTS;


void initSFX(void* sfx_SoundEffects) {
   PLY_AKM_INITSOUNDEFFECTS(sfx_SoundEffects);
   currentFx = SFX_NONE;
}


void playSFX(u8 fx) {
   currentFx = fx;
}


void activateSFX() {
   if (currentFx != SFX_NONE) {
      PLY_AKM_PLAYSOUNDEFFECT(currentFx, CHANNEL_B, 0);
      currentFx = SFX_NONE;
   }
}


/**
 * Init a new piece of music, or restart playing.
 * @param music
 */
void initMusic(void* music) {
   selMusic = music;
}


void activateMusic() {
   if (currentMusic != selMusic) {
      currentMusic = selMusic;
      PLY_AKM_INIT(currentMusic, SONG_MAIN);
   }
}


void playSound() {
   activateSFX();
   activateMusic();
__asm
      ;; Save registers before calling PLY_AKM_PLAY
      exx
      ex af',af   ;;' avoid compiler warnings
      push af
      push bc
      push de
      push hl
      push ix
      push iy

      call _PLY_AKM_PLAY

      ;; Revert back registers after calling
      pop iy
      pop ix
      pop hl
      pop de
      pop bc
      pop af
      ex af',af   ;;' avoid compiler warnings
      exx
__endasm;
}


void stopMusic() {
   selMusic = 0;
   currentMusic = 0;
   PLY_AKM_INIT(&MAIN_START, SONG_EMPTY);   // Play empty song to still be able to play sound effects.
}


void initSound() {
   initSFX(&SFX_SOUNDEFFECTS);
   initMusic(&MAIN_START);
}